import React, { useEffect, useState } from "react";
import { connect, useDispatch } from "react-redux";
import { actions } from "@redux/testRedux";
import { Container, Row, Col } from "react-bootstrap";
import Sidebar from "components/sidebar/sidebar";
import WhatWeHaveMore from "components/aboutShopstick/whatWeHaveMore";
import { actions as productActions } from "@redux/productRedux";
import ProductCard from "components/ourproducts/products";
import Categories from "components/explorecategories/exploreCategory";
import SpecialOffers from "components/ourOffers/specialOffers";
import HomePageSpecialOffers from "components/ourOffers/specialOfferHomePage";
import HomePageRegularOffers from "components/ourOffers/regularOfferHomePage";
import HomePageShopStickStore from "containers/home/homePageShopStickStore";
import banar from "../../image/banar.png";
import {
  CarouselProvider,
  Slider,
  Slide,
  ButtonBack,
  ButtonNext,
} from "pure-react-carousel";
import SliderDataAccess from "dataAccess/sliderDataAccess";
import { Link } from "react-router-dom";
import { Helmet } from "react-helmet";
import OfferCategory from "components/explorecategories/offerCategory";
import SpinnerLocal from "../../components/spinner";

const Home = (props) => {
  const dispatch = useDispatch();

  const [images, setImages] = useState([]);
  const [banner, setBanner] = useState([]);
  const [show,setShow]=useState(false);

  useEffect(() => {
    dispatch(actions.testAction());
   // dispatch(productActions.getHomePageProducts());
    setTimeout(function(){setShow(true)},2000)
  }, [dispatch]);

  useEffect(() => {
    SliderDataAccess.getSliderImage()
      .then((data) => {
        console.log(data);
        setImages(data.data.sliders);
        setBanner(data.data.banners);
      })
      .catch((error) => {});
  }, []);

  return (
    <div>
      <Helmet>
        <title> Genx | Online Shopping </title>
        <meta name="description" content="Shopstick Home page" />
      </Helmet>
      <Container
        className="slider-responsive"
        // style={{
        //   maxWidth: "100%",
        //   overflow: "hidden",
        //   paddingLeft: "35px",
        //   paddingRight: "35px",
        // }}
      >
        {banner.length === 0 && <SpinnerLocal height={'75vh'}/>}
        <Row className="sidebar-and-banner">
          {/* <Col xl={3} lg={3} md={3} sm={3} xs={12} style={{ height: "732px" }}>
            <Sidebar />
          </Col> */}
          <Col xl={12} lg={12} md={12} sm={12} xs={12}>
            <div className="home-banner">
              <CarouselProvider
                naturalSlideWidth={100}
                naturalSlideHeight={30}
                totalSlides={images.length}
                isPlaying={true}
                interval={3000}
                touchEnabled={true}
                isIntrinsicHeight={true}
                infinite={true}
              >
                {/* <Slider>
                  <Slide index={0}>
                    <Link to="/special-offers-all">
                      <img
                        src="/images/homebanner/MasterBanner1.jpg"
                        alt="banner"
                        style={{ borderRadius: "10px" }}
                      />
                    </Link>
                  </Slide>
                  <Slide index={1}>
                    <img
                      src="/images/homebanner/MasterBanner2.png"
                      alt="banner"
                      style={{ borderRadius: "10px" }}
                    />
                  </Slide>
                  <Slide index={2}>
                    <img
                      src="/images/homebanner/MasterBanner3.png"
                      alt="banner"
                      style={{ borderRadius: "10px" }}
                    />
                  </Slide>
                  <Slide index={3}>
                    <img
                      src="/images/homebanner/MasterBanner4.jpg"
                      alt="banner"
                      style={{ borderRadius: "10px" }}
                    />
                  </Slide>
                </Slider> */}
                <Slider>
                  {images !== undefined &&
                    images.map((single, index) => (
                      <Slide index={index}>
                          <img
                            src={single.en_image}
                            alt=""
                            style={{ borderRadius: "10px", height: "400px" }}
                          />
                      </Slide>
                    ))}
                </Slider>
              </CarouselProvider>
            </div>
            <Row className="home-banner-below ">
              {/* <Col
                xl={2}
                lg={2}
                md={3}
                sm={12}
                xs={12}
                className="home-banner-below-second-image d-flex justify-content-center mb-2"
              >
                <img src={banar} style={{ maxWidth: "100%" }} />
              </Col>
              <Col
                xl={2}
                lg={2}
                md={3}
                sm={12}
                xs={12}
                className="home-banner-below-second-image d-flex justify-content-center mb-2"
              >
                <img src={banar} style={{ maxWidth: "100%" }} />
              </Col>
              <Col
                xl={2}
                lg={2}
                md={3}
                sm={12}
                xs={12}
                className="home-banner-below-second-image d-flex justify-content-center mb-2"
              >
                <img src={banar} style={{ maxWidth: "100%" }} />
              </Col>
              <Col
                xl={2}
                lg={2}
                md={3}
                sm={12}
                xs={12}
                className="home-banner-below-second-image d-flex justify-content-center mb-2"
              >
                <img src={banar} style={{ maxWidth: "100%" }} />
              </Col>
              <Col
                xl={2}
                lg={2}
                md={3}
                sm={12}
                xs={12}
                className="home-banner-below-second-image d-flex justify-content-center mb-2"
              >
                <img src={banar} style={{ maxWidth: "100%" }} />
              </Col>
              <Col
                xl={2}
                lg={2}
                md={3}
                sm={12}
                xs={12}
                className="home-banner-below-second-image d-flex justify-content-center mb-2"
              >
                <img src={banar} style={{ maxWidth: "100%" }} />
              </Col> */}
              {banner !== undefined &&
                banner.map((single) => (
                  <Col
                    xl={2}
                    lg={2}
                    md={3}
                    sm={12}
                    xs={12}
                    className="home-banner-below-second-image d-flex justify-content-center"
                  >
                    <img src={single.en_image} style={{ maxWidth: "100%" }} />
                  </Col>
                ))}

              {/* <Col
                xl={6}
                lg={6}
                md={6}
                sm={12}
                xs={12}
                className="home-banner-below-second-image"
              >
                <img
                  src={
                    banner[1].en_image !== null
                      ? banner[0].en_image
                      : "/images/newImage/second.png"
                  }
                  style={{ maxWidth: "100%" }}
                />
              </Col> */}
            </Row>
          </Col>
        </Row>

        {/* <HomePageSpecialOffers />
        <HomePageRegularOffers /> */}
        <HomePageShopStickStore />
        {/* <WhatWeHaveMore /> */}
     {show ===true && <>
      <SpecialOffers />
        <OfferCategory />
        <Categories />
     </>}
        
      </Container>
    </div>
  );
};

const mapStateToProps = (state) => ({});

const mapDispatchToProps = {};

export default connect(mapStateToProps, mapDispatchToProps)(Home);
